<template>
    <client-only>
        <OwlCarousel
            :margin="20"
            :stage-padding="10"
            :dots="false"
            :nav="true"
            :items="items"
            class="ocarousel"
        >
            <div v-for="(product, p) in products" :key="'product-' + p">
                <div class="product-container mb-md-5 mt-md-0 mt-10">
                    <nuxt-link :to="'/products/' + product.slug">
                        <div class="hover-bg pointer">
                            <img
                                v-if="product.images.length > 1"
                                :src="product.images[1].url"
                                :alt="product.name"
                                class="image"
                            />
                        </div>
                    </nuxt-link>
                    <div class="product-wish">
                        <v-btn
                            v-if="checkWishlist(product.id) === 'mdi-heart'"
                            text
                            @click="removeFromWishlist(product.id)"
                        >
                            <v-icon
                                class="heart-icon-default"
                                v-html="checkWishlist(product.id)"
                            ></v-icon>
                        </v-btn>
                        <v-btn v-else text @click="addToWishlist(product.id)">
                            <v-icon
                                class="heart-icon-default"
                                v-html="checkWishlist(product.id)"
                            ></v-icon>
                        </v-btn>
                    </div>
                    <div
                        v-if="product.total_inventories_count == 0"
                        class="product-rented font-syne-bold"
                    >
                        <p style="background-color: red; color: white; margin: auto; width: 80px; text-align: center;">Rented</p>
                    </div>
                    <nuxt-link :to="'/products/' + product.slug">
                        <img
                            :src="product.images[0].url"
                            :alt="product.name"
                            class="image"
                        />
                    </nuxt-link>
                </div>
                <p class="product-title-text mb-1">
                    {{ product.brand.name }} {{ product.name }}
                </p>
                <p class="product-desc-text">
                    <!-- {{ p.size }}/{{ p.collection }}/ -->
                    {{ product.pricing[0].currency_code }}
                    {{ product.pricing[0].price }}
                </p>
            </div>
        </OwlCarousel>
    </client-only>
</template>

<script lang="ts">
import { Vue, Component, Prop } from 'vue-property-decorator'
import { mapGetters } from 'vuex'
import { Debounce } from 'lodash-decorators'

@Component({
    computed: {
        ...mapGetters({
            currency: 'currency/getCurrency',
            currencyName: 'currency/getCurrencyName',
            checkWishlist: 'wishlist/checkWishlist',
        }),
    },
})
export default class ProductCarousel extends Vue {
    @Prop() readonly products!: []

    // Data
    items: Number = 5
    message: any = null
    color: String = ''
    icon: String = ''

    @Debounce(500)
    async addToWishlist(id: number) {
        if (!this.$cookies.get('t')) {
            this.message = this.$t('auth.unAuthenticate')
            this.color = 'red'
            this.icon = 'mdi-close-circle'
        } else {
            const response = await this.$api.wishlist.addWishlist(id)

            if (response.data) {
                this.$store.dispatch('wishlist/addToWishlist', response.data)
                this.message = this.$t('notification.wishlist.added')
                this.color = 'green'
                this.icon = 'mdi-check'
            }
        }

        const val = {
            text: this.message,
            color: this.color,
            icon: this.icon,
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)
    }

    @Debounce(500)
    async removeFromWishlist(id: number) {
        if (!this.$cookies.get('t')) {
            this.message = this.$t('auth.wishlistAuth')
            this.color = 'red'
            this.icon = 'mdi-close-circle'
        } else {
            const deleteResponse = await this.$api.wishlist.deleteWishlist(id)

            if (deleteResponse) {
                this.$store.dispatch('wishlist/removeFromWishlist', id)
                this.message = this.$t('notification.wishlist.removed')
                this.color = 'green'
                this.icon = 'mdi-check'
            }
        }

        const val = {
            text: this.message,
            color: this.color,
            icon: this.icon,
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)
    }

    mounted() {
        if (process.browser) {
            if (window.innerWidth <= 460) this.items = 2
        }
    }
}
</script>
